/*jslint nomen: true, indent: 2, maxerr: 3, maxlen: 80*/
/*global window, RSVP, rJS, jIO*/
(function(window, RSVP, rJS, jIO) {
  "use strict";
  rJS(window)

  .declareAcquiredMethod("get_model", "get_model")

  .declareMethod("read_file_new", function(link){
    var gadget = this,
        storage;
    return gadget.get_model()
      .push(function(result){
        storage = result;
      })
      .push (function(){
        var xmlhttp = new XMLHttpRequest();
        xmlhttp.onreadystatechange = function() {
          if (xmlhttp.status == 200 && xmlhttp.readyState == 4){
            var rss,
                title;
            rss = xmlhttp.responseText;
            title = rss.slice(rss.indexOf("<title>")+7, rss.indexOf("</title>"));
            return gadget.is_already_loaded(title)
              .push(function(is_loaded){
                if (!is_loaded){
                  return gadget.remove_css(rss)
                    .push(function(rss_without_css){
                      return storage.add_attachment(title, rss_without_css);
                    })
                    .push(function(){
                      return storage.loaded_doc(title, {"loaded" : "true"});
                    });
                }
              });
          }
        };
        xmlhttp.open("GET", link, true);
        xmlhttp.send();
      });
  })

  .declareMethod("remove_css", function(body){
    var regEx = new RegExp('(style="(.*?)"|style=&quot(.*?)&quot)', 'gi');
    return body.replace(regEx, "");
  })

  .declareMethod("is_already_loaded", function(title){
    return this.get_model()
      .push(function(storage){
        return storage.all_loaded_docs();
      })
      .push(function (result){
        var i;
        for (i = 0; i<result.data.rows.length; i+=1){
          if (result.data.rows[i].id === title) return true;
        }
        return false;
      });
  });

}(window, RSVP, rJS, jIO));
