/*jslint nomen: true, indent: 2, maxerr: 3, maxlen: 80*/
/*global window, RSVP, rJS, jIO*/
(function(window, RSVP, rJS, jIO) {
    "use strict";
    rJS(window)

    .declareMethod("addItem", function(item, key) {
      var list,
          list_item,
          title,
          link,
          body,
          body_text,
          parser,
          xmlDoc;

      list = document.getElementById("list");
      list_item = document.createElement("LI");

      title = document.createElement("a");
      title.appendChild(document.createTextNode(item.title));
      title.className="title";
      title.href = item.link;
      list_item.appendChild(title);
      
      link = document.createElement("a");
      link.appendChild(document.createTextNode(item.link));
      link.href = item.link;
      link.className = "link";
      var link_par = document.createElement('p');
      link_par.appendChild(link);
      list_item.appendChild(link_par);
      
      body = document.createElement('p');
      body.className = "body";
      if (key === ""){
        body.innerHTML = "";
        list.appendChild(list_item);
      } else {
        return this.cut_description(item.body, key)
        .push(function (result){
          var array = [...result.matchAll(key)],
              i;
          for (i=0; i<array.length; i+=1){
            result = result.slice(0, array[i].index) + "<b>" + result.slice(array[i].index, array[i].index+array[i][0].length+1) + "</b>" + result.slice(array[i].index+array[i][0].length+1);
          }
          body.innerHTML = result;
          list_item.appendChild(body);
          list.appendChild(list_item);
        });
        
      }
    })
    
    .declareMethod("clear", function(){
      var list = document.getElementById("list");
      while (list.firstChild) {
        list.removeChild(list.firstChild);
      }
    })
    
    .declareMethod("cut_description", function(body, key){
      var regEx,
          result;
      regEx = new RegExp('[^.?!]*' + ' ' + key + ' ' + '[^.?!]*[.?!]', 'gm');
      result = regEx.exec(body);
      if (result === null) {
        return new RegExp('[^.?!]*[.?!]').exec(body)[0];
      }
      else return result[0].slice(1);
    });

}(window, RSVP, rJS, jIO));