(function (window, document, rJS, RSVP) {
  var gadget;
  rJS(window)

  .setState({
   model_gadget : null,
   parser_gadget : null,
   result_gadget : null,
   to_load: [
     "allemandfacile.rss",
     "anglaisfacile.rss",
     "espagnolfacile.rss",
     "francaisfacile.rss",
     "hgeo_college.rss",
     "histoirencours.rss",
     "italienfacile.rss",
     "lewebpedagogique-lapasserelle.rss",
     "mathematiquesfacile.rss",
     "physique_chimie_college.rss",
     "technologieaucollege27.rss",
     "vivelessvt.rss"
     ]
  })

  .ready(function(){
      var model_gadget,
          result_gadget;

    console.log("ready !");
    var gadget = this;
    return gadget.getDeclaredGadget("model")
      .push(function(model){
        model_gadget = model;
      })
      .push(function(){
        return gadget.getDeclaredGadget("result");
      })
      .push(function(result){
        result_gadget = result;
      })
      .push(function(){
        return gadget.getDeclaredGadget("parser");
      })
      .push(function(result){
        return gadget.changeState({
          model_gadget : model_gadget,
          parser_gadget : result,
          result_gadget : result_gadget
        });
      });
  })

  .onStateChange(function (modification_dict){
    var gadget = this,
        promise_list = [],
        i;
    for (i = 0; i < gadget.state.to_load.length; i++){
      promise_list.push(gadget.state.parser_gadget.read_file_new("./test-files/" + gadget.state.to_load[i]));
    }
    promise_list.push(gadget.state.model_gadget.load_index());
    RSVP.all(promise_list);
  })
  
  .allowPublicAcquisition("get_model", function(){
    return this.getDeclaredGadget("model");
  })

  .declareMethod("search", function (key){
    var gadget = this;
    return gadget.state.result_gadget.clear()
      .push(function(){
        return gadget.state.model_gadget.search(key);
      })
      .push(function(result){
        if (result.length === 0) {
            return gadget.state.result_gadget.addItem({
              title : "No results found",
              link : ""
            }, "");
        } else {
          var i, promise_list = [];
          for (i=0; i<result.length; i+=1){
            promise_list.push(gadget.state.result_gadget.addItem(result[i].doc, key));
          }
          return RSVP.all(promise_list);
        }
      });
  })

  .onEvent("submit", function(event){
    this.search(event.target.elements[0].value);
  });
}(window, document, rJS, RSVP));
